/* ------------------------------------------------------------- */
/* File: example0.c                                              */
/* ------------------------------------------------------------- */

/*
  Correct result when compilesd with

  gcc -I. -Wall -Wextra -g -O1 -o example_correct example0.c -lm

  Wrong output with

  gcc -I. -Wall -Wextra -g -O1 -foptimize-sibling-calls -o example_wrong example0.c -lm


  This program should create the following output:
  
  2.000000
  3.000000
  [...]
  99.000000
  
  however, with the optimatization flag '-foptimize-sibling-calls'

  the result is 

  30.257395
  30.619231
  [...]
  99.000000

  See also remarks below.

*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>


/* the error disappears when this function prototype is declare static! */
double sample(void);

/* ------------------------------------------------------------- */

int main(void)
{
  int    i;     /* loop variable                                 */
  double x;     /* will hold the random number                   */

  for (i=0; i<98; i++) {
    x = sample();
    x = (x <= 0.7) ? (x*x/0.7) : ((0.7 + x * (x-2.))/(-0.3));
    x = 100. * (x + 0.005);
    printf("%f\n",x);
  }

  exit (EXIT_SUCCESS);

} 

/* ------------------------------------------------------------- */

double sample(void)
{
  static double U = 5.e-3;

  U += 1.e-2;

  if (U<=0.7) {
    /* The error occurs here !! */
    /* This if branch is never reached even when U is less then 0.7 */
    return ( sqrt(0.7*U) );
  }
  else {
    return ( (0.3*(1.-U)) ? (1.-sqrt(0.3*(1.-U))) : 1. ); 
  }

  /*
    Remark adding some additional function calls, e.g. a 'printf' statement
    removes this error!
  */

} 

/*---------------------------------------------------------------------------*/

